/*
 Copyright (C) 2005 Michael Hanselmann
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 $Id: case.c,v 1.2 2005/04/30 23:09:19 michael Exp $
*/

#include <stdlib.h>
#include <ctype.h>
#include "pmt.h"

PMT_MODULE_INIT(tolower) {
    return 1;
}

PMT_MODULE_INIT(toupper) {
    return 1;
}

#define CASE_IMPL(func) \
    for(int i = 0; i < len; ++i) { \
        if(isalpha(buf[i])) { \
            buf[i] = func(buf[i]); \
        } \
    }

PMT_MODULE_IMPL(tolower) {
    CASE_IMPL(tolower);
}

PMT_MODULE_IMPL(toupper) {
    CASE_IMPL(toupper);
}

PMT_MODULE_END(tolower) { }
PMT_MODULE_END(toupper) { }
