#ifndef _PMT_H
#define _PMT_H

#define TIMEDIFF(a, b) \
    (((double)(b.tv_sec - a.tv_sec) * 1000) + \
     ((double)(b.tv_usec - a.tv_usec) / 1000))

#define PMT_MODULE_P(varname) \
    void (*varname)(size_t, char*)

#define PMT_MODULE_INITP(varname) \
    int (*varname)(int, char**)

#define PMT_MODULE_ENDP(varname) \
    void (*varname)()

#define PMT_MODULE_DEF(f) \
    void f##_do(size_t, char*);\
    int f##_init(); \
    void f##_end();

#define PMT_MODULE_IMPL(f) \
    void f##_do(size_t len, char* buf)

#define PMT_MODULE_INIT(f) \
    int f##_init(int argc, char* argv[])

#define PMT_MODULE_END(f) \
    void f##_end()

#define PMT_MODULE_TABLE_ENTRY(name, desc, params) \
    { #name, desc, name##_do, name##_init, name##_end, params }

struct pmt_module_parameters {
    const char* parameter;
    const char* desc;
};

struct pmt_module_info {
    const char* name;
    const char* desc;
    PMT_MODULE_P(func);
    PMT_MODULE_INITP(func_init);
    PMT_MODULE_ENDP(func_end);
    struct pmt_module_parameters* parameters;
};

extern unsigned long long sum;

#endif
