/*
 Copyright (C) 2005 Michael Hanselmann
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 $Id: speed.c,v 1.3 2005/04/30 23:23:27 michael Exp $
*/

#define _BSD_SOURCE
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include "pmt.h"
#include "fmt.h"

static struct timeval tv, last_tv, first_tv;

PMT_MODULE_INIT(speed) {
    timerclear(&tv);
    timerclear(&last_tv);
    gettimeofday(&first_tv, NULL);
    return 1;
}

PMT_MODULE_IMPL(speed) {
    gettimeofday(&tv, NULL);
    if(timerisset(&last_tv)) {
        float duration = TIMEDIFF(last_tv, tv);
        char tmp[16];

        write(STDERR_FILENO, "\rSpeed avg: ", 12);
        write(STDERR_FILENO, tmp, fmt_humank(tmp, sum / TIMEDIFF(first_tv, tv) * 1024));
        write(STDERR_FILENO, "/s, Speed now: ", 15);
        write(STDERR_FILENO, tmp, fmt_humank(tmp, len / duration * 1024));
        write(STDERR_FILENO, "/s, Total: ", 11);
        write(STDERR_FILENO, tmp, fmt_humank(tmp, sum));
        write(STDERR_FILENO, "\033[K", 3);
    }

    gettimeofday(&last_tv, NULL);
}

PMT_MODULE_END(speed) {
    write(STDERR_FILENO, "\n", 1);
}

